SystemOrganization addCategory: #Pharobot!

TransformationMorph subclass: #Robot
	instanceVariableNames: 'mundo direccion estado_pincelArriba estado_pincelAbajo estado_pincelActual'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pharobot'!

!Robot class methodsFor: 'crear instancia' stamp: 'MorellatoAriel 2/28/2012 16:42'!
"Luego de crear un robot hay que mandarle el mensaje 'inicializarRobot' "

crearRobot: unMundo

|nuevoRobot|

nuevoRobot:= self new.
nuevoRobot mundo: unMundo.
nuevoRobot mundo robot: nuevoRobot.
nuevoRobot position: nuevoRobot mundo position.
^ nuevoRobot openInWorld .
! !

!Robot methodsFor: 'pincel' stamp: 'MorellatoAriel 2/28/2012 17:39'!
bajarPincel

self estado_pincelActual: self estado_pincelAbajo.! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/28/2012 00:40'!
direccion
	^ self angle radiansToDegrees .! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/28/2012 00:39'!
direccion: unAngulo
	self angle: unAngulo degreesToRadians.! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
estado_pincelAbajo
	^ estado_pincelAbajo! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
estado_pincelAbajo: anObject
	estado_pincelAbajo := anObject! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
estado_pincelActual
	^ estado_pincelActual! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
estado_pincelActual: anObject
	estado_pincelActual := anObject! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
estado_pincelArriba
	^ estado_pincelArriba! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
estado_pincelArriba: anObject
	estado_pincelArriba := anObject! !

!Robot methodsFor: 'inicializar' stamp: 'MorellatoAriel 2/28/2012 00:04'!
inicializarRobot

"Se une el robot con su mundo"
self mundo addMorph: self.


! !

!Robot methodsFor: 'movimiento' stamp: 'MorellatoAriel 2/28/2012 17:55'!
mover: unaLongitud 

self estado_pincelActual mover: unaLongitud.! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
mundo
	^ mundo! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
mundo: anObject
	mundo := anObject! !

!Robot methodsFor: 'pincel' stamp: 'MorellatoAriel 2/28/2012 17:42'!
pincelAbajo 

^ self estado_pincelActual pincelAbajo .! !

!Robot methodsFor: 'pincel' stamp: 'MorellatoAriel 2/28/2012 17:42'!
pincelArriba  

^ self estado_pincelActual pincelArriba .! !

!Robot methodsFor: 'pincel' stamp: 'MorellatoAriel 2/28/2012 17:39'!
subirPincel

self estado_pincelActual: self estado_pincelArriba .! !

Morph subclass: #Mundo
	instanceVariableNames: 'robot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pharobot'!

!Mundo class methodsFor: 'crear instancia' stamp: 'MorellatoAriel 2/27/2012 23:50'!
"El tamao es pasado de la siguiente manera    140 @ 140 donde los valores de X e Y deben ser multiplos de 70"

crearMundo: unaSuperficie

|mundo nroRepeticionesEnX nroRepeticionesEnY posicionActual cuadriculaNueva|

"Chequear datos ingresados"

((unaSuperficie x isDivisibleBy: 70) & (unaSuperficie y isDivisibleBy: 70))
ifFalse: [ self error: 'Los valores ingresados deben ser multiplos de 70'].

mundo:= self new.
mundo color: (Color black alpha: 0.3).
mundo extent: unaSuperficie.

"Cuadriculado"

nroRepeticionesEnX:= mundo extent x // 70.
nroRepeticionesEnY:= mundo extent y // 70.
posicionActual:= mundo position.

(nroRepeticionesEnY) timesRepeat: 
[(nroRepeticionesEnX) timesRepeat: [ cuadriculaNueva:= CuadriculaDeMundo crearCuadriculaDeMundo.	
								cuadriculaNueva position: posicionActual.
								mundo addMorph: cuadriculaNueva.
								posicionActual:= (posicionActual x + 70) @ (posicionActual y)].
							
	posicionActual:= (posicionActual x - (nroRepeticionesEnX * 70) @ (posicionActual y + 70)) ].

^ mundo openInWorld .! !

!Mundo methodsFor: 'extenciones' stamp: 'MorellatoAriel 2/28/2012 16:49'!
ampliarParaMoverEnX: unaLongitud delRobot: unRobot

((unRobot left - unRobot mundo left)abs <= unaLongitud)
"Se extiende al oeste"
ifTrue: [ self extenderAlOeste: unaLongitud.
		self robot inicializarRobot .] .

(((unRobot left + unRobot extent x)-(unRobot mundo left + unRobot mundo extent x))abs <= unaLongitud) 
"Se extiende al este"
ifTrue: [ self extenderAlEste: unaLongitud.
		self robot inicializarRobot . ].! !

!Mundo methodsFor: 'extenciones' stamp: 'MorellatoAriel 2/28/2012 16:48'!
ampliarParaMoverEnY: unaLongitud delRobot: unRobot

((unRobot top - unRobot mundo top)abs <= unaLongitud) 
"Se extiende al norte"
ifTrue: [ self extenderAlNorte:  unaLongitud.
		self robot inicializarRobot .] .

(((unRobot top + unRobot extent y)-(unRobot mundo top + unRobot mundo extent y))abs <= unaLongitud)
"Se extiende al sur"
ifTrue: [ self extenderAlSur:  unaLongitud.
		self robot inicializarRobot .]! !

!Mundo methodsFor: 'dibujos' stamp: 'MorellatoAriel 2/28/2012 17:33'!
dibujarLineaDesde: ptoInicio conLongitud: unaLongitud conInclinacion: unAngulo

|ptoActual longEnX longEnY|

ptoActual:= ptoInicio.
longEnX:= self robot angle cos * 1.
longEnY:= self robot angle sin * 1.


(unaLongitud // 1) timesRepeat: 
[ 	self dibujarPunto: ptoActual.
	ptoActual:= (ptoActual x + longEnX) @ (ptoActual y + longEnY) ]

! !

!Mundo methodsFor: 'dibujos' stamp: 'MorellatoAriel 2/28/2012 17:49'!
dibujarPunto: posicion

|nuevoPunto|

nuevoPunto:= Morph new.
nuevoPunto extent: 10@10.
nuevoPunto position: posicion.
^ nuevoPunto openInWorld .! !

!Mundo methodsFor: 'extenciones' stamp: 'MorellatoAriel 2/28/2012 16:40'!
extenderAlEste: unaLongitud

|cuadriculasAExtender nuevoMundo|

cuadriculasAExtender:= (unaLongitud // 70 ) + 1.
nuevoMundo:= Mundo crearMundo: (self extent x + (cuadriculasAExtender * 70)) @ (self extent y ).
nuevoMundo position: self position.
nuevoMundo robot: self robot.
self robot mundo: nuevoMundo.
self delete.
^ nuevoMundo openInWorld .
! !

!Mundo methodsFor: 'extenciones' stamp: 'MorellatoAriel 2/28/2012 16:40'!
extenderAlNorte: unaLongitud

|cuadriculasAExtender nuevoMundo|

cuadriculasAExtender:= (unaLongitud // 70 ) + 1.
nuevoMundo:= Mundo crearMundo: (self extent x) @ (self extent y + (cuadriculasAExtender * 70)).
nuevoMundo position: (self position x) @ (self position y - (cuadriculasAExtender * 70)).
nuevoMundo robot: self robot.
self robot mundo: nuevoMundo.
self delete.
^ nuevoMundo openInWorld .
! !

!Mundo methodsFor: 'extenciones' stamp: 'MorellatoAriel 2/28/2012 16:40'!
extenderAlOeste: unaLongitud

|cuadriculasAExtender nuevoMundo|

cuadriculasAExtender:= (unaLongitud // 70 ) + 1.
nuevoMundo:= Mundo crearMundo: (self extent x + (cuadriculasAExtender * 70)) @ (self extent y ).
nuevoMundo position: (self position x - (cuadriculasAExtender * 70) @ (self position y)).
nuevoMundo robot: self robot.
self robot mundo: nuevoMundo.
self delete.
^ nuevoMundo openInWorld .
! !

!Mundo methodsFor: 'extenciones' stamp: 'MorellatoAriel 2/28/2012 17:50'!
extenderAlSur: unaLongitud

|cuadriculasAExtender nuevoMundo|

cuadriculasAExtender:= (unaLongitud // 70 ) + 1.
nuevoMundo:= Mundo crearMundo: (self extent x) @ (self extent y + (cuadriculasAExtender * 70)).
nuevoMundo position: self position.
nuevoMundo robot: self robot.
self robot mundo: nuevoMundo.
self delete.
^ nuevoMundo openInWorld .
! !

!Mundo methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:32'!
robot
	^ robot! !

!Mundo methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:32'!
robot: anObject
	robot := anObject! !

BorderedMorph subclass: #CuadriculaDeMundo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pharobot'!

!CuadriculaDeMundo class methodsFor: 'crear instancia' stamp: 'MorellatoAriel 2/27/2012 22:52'!
crearCuadriculaDeMundo

|cuadricula|
cuadricula:= BorderedMorph new.
cuadricula extent: 70@70.
cuadricula color: (Color black alpha: 0).
^ cuadricula openInWorld .! !

Object subclass: #EstadoDelRobot
	instanceVariableNames: 'robot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pharobot'!

!EstadoDelRobot class methodsFor: 'crear instancia' stamp: 'MorellatoAriel 2/28/2012 00:17'!
"Luego de crear un EstadoDelRobot  hay que mandarle el mensaje inicializarEstadoEnRobot "

crearEstado: unRobot

|estado|

estado:= self new.
estado robot: unRobot.
^ estado.! !

!EstadoDelRobot methodsFor: 'inicializacion' stamp: 'MorellatoAriel 2/28/2012 00:19'!
inicializarEstadoEnRobot

"El robot comienza con un EsadoActual = Estado_PincelArriba"
self subclassResponsibility .! !

!EstadoDelRobot methodsFor: 'movimientos' stamp: 'MorellatoAriel 2/28/2012 16:56'!
mover: unaLongitud

|movimientoEnX movimientoEnY|

movimientoEnX:= self robot angle cos * unaLongitud.
movimientoEnY:= self robot angle sin * unaLongitud.

"Movimiento en x"

self robot position: (self robot position x + movimientoEnX) @ (self robot position y).
self robot mundo ampliarParaMoverEnX: movimientoEnX abs delRobot: self robot.


"Movimiento en y"

self robot position: (self robot position x) @ (self robot position y - movimientoEnY).
self robot mundo ampliarParaMoverEnY: movimientoEnY abs delRobot: self robot.! !

!EstadoDelRobot methodsFor: 'pincel' stamp: 'MorellatoAriel 2/28/2012 00:12'!
pincelAbajo

self subclassResponsibility .! !

!EstadoDelRobot methodsFor: 'pincel' stamp: 'MorellatoAriel 2/28/2012 00:12'!
pincelArriba

self subclassResponsibility .! !

!EstadoDelRobot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/28/2012 00:11'!
robot
	^ robot! !

!EstadoDelRobot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/28/2012 00:11'!
robot: anObject
	robot := anObject! !

EstadoDelRobot subclass: #Estado_PincelAbajo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pharobot'!

!Estado_PincelAbajo methodsFor: 'inicializacion' stamp: 'MorellatoAriel 2/28/2012 16:53'!
inicializarEstadoEnRobot 

self robot estado_pincelAbajo: self.! !

!Estado_PincelAbajo methodsFor: 'movimientos' stamp: 'MorellatoAriel 2/28/2012 16:59'!
mover: unaLongitud

super mover: unaLongitud.
self robot mundo dibujarLineaDesde: self robot position conLongitud: unaLongitud conInclinacion: self robot angle.! !

!Estado_PincelAbajo methodsFor: 'pincel' stamp: 'MorellatoAriel 2/28/2012 17:40'!
pincelAbajo 

^ true.! !

!Estado_PincelAbajo methodsFor: 'pincel' stamp: 'MorellatoAriel 2/28/2012 17:40'!
pincelArriba 

^ false.! !

EstadoDelRobot subclass: #Estado_PincelArriba
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pharobot'!

!Estado_PincelArriba methodsFor: 'inicializacion' stamp: 'MorellatoAriel 2/28/2012 00:19'!
inicializarEstadoEnRobot 

self robot estado_pincelArriba: self.
self robot estado_pincelActual: self.! !

!Estado_PincelArriba methodsFor: 'pincel' stamp: 'MorellatoAriel 2/28/2012 17:40'!
pincelAbajo  

^ false.! !

!Estado_PincelArriba methodsFor: 'pincel' stamp: 'MorellatoAriel 2/28/2012 17:40'!
pincelArriba 

^ true.! !
